<?php
function _newsUpdate()
{
	global $objDatabase, $_ARRAYLANG;

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_news");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_news'));
		return false;
	}

	if (!in_array('teaser_show_link', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_news` ADD `teaser_show_link` TINYINT( 1 ) UNSIGNED DEFAULT '1' NOT NULL AFTER `teaser_text`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "ALTER TABLE `".DBPREFIX."module_news` CHANGE `teaser_frames` `teaser_frames` TEXT NOT NULL";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."module_news` CHANGE `teaser_text` `teaser_text` TEXT NOT NULL";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."module_news`
		CHANGE `validated` `validated` enum('0','1') NOT NULL default '0',
  		CHANGE `teaser_only` `teaser_only` enum('0','1') NOT NULL default '0'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrNewsSettings = array(
		'news_feed_image'		=> ''
	);

	foreach ($arrNewsSettings as $name => $value) {
		$query = "SELECT name FROM `".DBPREFIX."module_news_settings` WHERE `name`='".$name."'";
		if (($objSettings = $objDatabase->Execute($query)) !== false) {
			if ($objSettings->RecordCount() == 0) {
				$query = "INSERT INTO `".DBPREFIX."module_news_settings` ( `name`, `value` ) VALUES ('".$name."', '".$value."')";
				if ($objDatabase->Execute($query) === false) {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	// create / update newsticker
	$arrTables = $objDatabase->MetaTables('TABLES');
	if ($arrTables !== false) {
		if (!in_array(DBPREFIX."module_news_ticker", $arrTables)) {
			$query = "CREATE TABLE `".DBPREFIX."module_news_ticker` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`name` VARCHAR( 255 ) NOT NULL DEFAULT '',
			`charset` ENUM( 'ISO-8859-1', 'UTF-8' ) NOT NULL DEFAULT 'ISO-8859-1',
			`urlencode` tinyint(1) unsigned NOT NULL default '0',
			`prefix` varchar(250) NOT NULL default '',
			UNIQUE ( `name` )
			) ENGINE = MYISAM";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			} else {
				$tickerIsNew = true;
			}
		}
	} else {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	$query = "SELECT 1 FROM `".DBPREFIX."module_news_ticker`";
	$objResult = $objDatabase->SelectLimit($query, 1);
	if ($objResult !== false) {
		if ($objResult->RecordCount() == 0) {
			$query = "SELECT `value` FROM `".DBPREFIX."module_news_settings` WHERE `name` = 'news_ticker_filename'";
			$objResult = $objDatabase->SelectLimit($query, 1);
			if ($objResult !== false) {
				if ($objResult->RecordCount() == 1) {
					$tickerName = $objResult->fields['value'];
				} elseif ($tickerIsNew) {
					$tickerName = 'newsticker.txt';
				} else {
					$tickerName = null;
				}

				if (!empty($tickerName)) {
					$query = "INSERT INTO `".DBPREFIX."module_news_ticker` (`name`) VALUES ('".addslashes($tickerName)."')";
					if ($objDatabase->Execute($query) === false) {
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
				}
			} else {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "DELETE FROM `".DBPREFIX."module_news_settings` WHERE `name` = 'news_ticker_filename'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	// change placeholder TXT_NEWS_CONTENT to TXT_NEWS_NEWS_CONTENT
	foreach (array('content', 'content_history', 'module_repository') as $table) {
		$query = "SELECT `id`, `content` FROM ".DBPREFIX.$table." WHERE `content` LIKE '%TXT_NEWS_CONTENT%' OR `content` LIKE '%NEWS_CAT_MENU%' OR `content` LIKE '%FCKeditorAPI.GetInstance(\'newsText\').SetHTML(\'\')%'";
		$objContent = $objDatabase->Execute($query);
		if (!$objContent) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		while (!$objContent->EOF) {
			$query = "UPDATE `".DBPREFIX.$table."` SET `content`='".addslashes(str_replace(array('TXT_NEWS_CONTENT', 'NEWS_CAT_MENU', 'FCKeditorAPI.GetInstance(\'newsText\').SetHTML(\'\')'), array('TXT_NEWS_NEWS_CONTENT', "<!-- BEGIN news_category_menu --><option value=\"{NEWS_CATEGORY_ID}\">{NEWS_CATEGORY_TITLE}</option><!-- END news_category_menu -->", 'FCKeditorAPI.GetInstance(\'newsText\').SetData(\'\')'), $objContent->fields['content']))."' WHERE `id`=".$objContent->fields['id'];
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
			$objContent->MoveNext();
		}
	}

	$query = "SELECT `name`, `value` FROM `".DBPREFIX."module_news_settings` WHERE `name` = 'news_ticker_filename' AND `value` = 'newsticker.txt'";
	$objResult = $objDatabase->SelectLimit($query, 1);
	if ($objResult !== false) {
		if ($objResult->RecordCount() == 0){
			$query = "INSERT INTO `".DBPREFIX."module_news_settings` (`name`, `value`) VALUES ('news_ticker_filename', 'newsticker.txt')";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_news");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_news'));
		return false;
	}

	if (!in_array('redirect', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_news` ADD `redirect` VARCHAR( 250 ) NOT NULL DEFAULT '' AFTER `text`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."module_news` CHANGE `redirect` `redirect` VARCHAR( 250 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "
    ALTER TABLE ".DBPREFIX."module_news
    CHANGE COLUMN id id integer(6) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN catid catid integer(2) UNSIGNED NOT NULL default '0',
    CHANGE COLUMN lang lang integer(2) UNSIGNED NOT NULL default '0',
    CHANGE COLUMN userid userid integer(6) UNSIGNED NOT NULL default '0'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."module_news_categories
    CHANGE COLUMN catid catid integer(2) UNSIGNED NOT NULL auto_increment,
    CHANGE COLUMN lang lang integer(2) UNSIGNED NOT NULL default '1'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }
    $query = "
    ALTER TABLE ".DBPREFIX."module_news_teaser_frame
    CHANGE COLUMN lang_id lang_id integer(3) UNSIGNED NOT NULL default '0'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }

    $arrIndexes = $objDatabase->MetaIndexes(DBPREFIX."module_news");
	if ($arrIndexes !== false) {
		if (isset($arrIndexes['newsindex'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_news` DROP INDEX `newsindex`";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		$query = "ALTER TABLE `".DBPREFIX."module_news` ADD FULLTEXT `newsindex` ( `text` , `title` , `teaser_text` )";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_news'));
		return false;
	}

	return true;
}
?>