<?php
function _feedUpdate()
{
	global $objDatabase, $_ARRAYLANG;

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_feed_newsml_documents");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_feed_newsml_documents'));
		return false;
	}

	if (!in_array('is_associated', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_documents` ADD `is_associated` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `dataContent`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_documents` CHANGE `is_associated` `is_associated` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('media_type', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_documents` ADD `media_type` ENUM( 'Text', 'Graphic', 'Photo', 'Audio', 'Video', 'ComplexData' ) NOT NULL DEFAULT 'Text' AFTER `is_associated`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('properties', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_documents` ADD `properties` TEXT NOT NULL AFTER `media_type`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('source', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_documents` ADD `source` TEXT NOT NULL AFTER `media_type`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrTables = $objDatabase->MetaTables('TABLES');
	if (!$arrTables) {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	if (!in_array(DBPREFIX."module_feed_newsml_association", $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_feed_newsml_association` (`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,`pId_master` TEXT NOT NULL ,`pId_slave` TEXT NOT NULL) ENGINE = MYISAM";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (in_array(DBPREFIX."module_feed_newsml_content_item", $arrTables)) {
		$query = "DROP TABLE `".DBPREFIX."module_feed_newsml_content_item`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_feed_newsml_categories");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_feed_newsml_categories'));
		return false;
	}

	if (!in_array('showPics', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_categories` ADD `showPics` ENUM( '0', '1' ) NOT NULL DEFAULT '1' AFTER `limit`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

    $query = "
    ALTER TABLE ".DBPREFIX."module_feed_newsml_documents
    CHANGE COLUMN revisionId revisionId integer(5) UNSIGNED NOT NULL default '0'
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }

    $query = 'SELECT `publicIdentifier`, COUNT(1) as `entry_count` FROM `'.DBPREFIX.'module_feed_newsml_documents` GROUP BY `publicIdentifier` ORDER BY `entry_count` DESC';
    $objRedundantEntry = $objDatabase->SelectLimit($query, 10);
	if ($objRedundantEntry !== false) {
		while (!$objRedundantEntry->EOF && $objRedundantEntry->fields['entry_count'] > 1) {
			while (!$objRedundantEntry->EOF) {
				if ($objRedundantEntry->fields['entry_count'] > 1) {
					$objEntry = $objDatabase->SelectLimit("DELETE FROM `".DBPREFIX."module_feed_newsml_documents` WHERE `publicIdentifier` = '".$objRedundantEntry->fields['publicIdentifier']."' ORDER BY `id` DESC", $objRedundantEntry->fields['entry_count']-1);
				} else {
					break 2;
				}
				$objRedundantEntry->MoveNext();
			}

			$objRedundantEntry = $objDatabase->SelectLimit($query, 10);
			if ($objRedundantEntry === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_documents` CHANGE `publicIdentifier` `publicIdentifier` VARCHAR( 255 ) NOT NULL DEFAULT ''";
	if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }

	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX.'module_feed_newsml_documents');
	if ($arrIndexes !== false) {
		if (!isset($arrIndexes['unique'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_documents` ADD UNIQUE `unique` (`publicIdentifier`)";
			if (!$objDatabase->Execute($query)) {
		    	return _databaseError($query, $objDatabase->ErrorMsg());
		    }
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_feed_newsml_documents'));
		return false;
	}

    return true;
}
?>